scala.tools.nsc.backend.jvm.GenASM

# JBuilder

#### abstract class JBuilder extends AnyRef

basic functionality for class file building

Source
  GenASM.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
JBeanInfoBuilder, JCommonBuilder, JMirrorBuilder, JPlainBuilder
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. JBuilder
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new JBuilder(bytecodeWriter: GenASM.BytecodeWriter, needsOutfile: Boolean)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from JBuilder to any2stringadd[JBuilder] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (JBuilder, B)

   Implicit information
     This member is added by an implicit conversion from JBuilder to ArrowAssoc[JBuilder] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### val CLASS_CONSTRUCTOR_NAME: String

7. #### val EMPTY_STRING_ARRAY: Array[String]

8. #### val INNER_CLASSES_FLAGS: Int

9. #### val INSTANCE_CONSTRUCTOR_NAME: String

10. #### def addInnerClasses(csym: Global.Symbol, jclass: ClassVisitor): Unit

11. #### final def asInstanceOf[T0]: T0

    Definition Classes
      Any

12. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

13. #### def createJAttribute(name: String, b: Array[Byte], offset: Int, len: Int): Attribute

14. #### def createJClass(access: Int, name: String, signature: String, superName: String, interfaces: Array[String]): ClassWriter

    Returns a new ClassWriter for the class given by arguments.

    Returns a new ClassWriter for the class given by arguments.

    access

      the class's access flags. This parameter also indicates if the class is deprecated.

    name

      the internal name of the class.

    signature

      the signature of this class. May be `null` if the class is not a generic one, and does not extend or implement generic classes or interfaces.

    superName

      the internal of name of the super class. For interfaces, the super class is `Object`. May be `null`, but only for the `Object` class.

    interfaces

      the internal names of the class's interfaces (see `getInternalName`). May be `null`.

15. #### def descriptor(s: Global.Symbol): String

16. #### def descriptor(k: Global.icodes.TypeKind): String

17. #### def descriptor(t: Global.Type): String

18. #### def ensuring(cond: (JBuilder) ⇒ Boolean, msg: ⇒ Any): JBuilder

    Implicit information
      This member is added by an implicit conversion from JBuilder to Ensuring[JBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: (JBuilder) ⇒ Boolean): JBuilder

    Implicit information
      This member is added by an implicit conversion from JBuilder to Ensuring[JBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean, msg: ⇒ Any): JBuilder

    Implicit information
      This member is added by an implicit conversion from JBuilder to Ensuring[JBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: Boolean): JBuilder

    Implicit information
      This member is added by an implicit conversion from JBuilder to Ensuring[JBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

23. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

24. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

25. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from JBuilder to StringFormat[JBuilder] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

26. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

27. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

28. #### val innerClassBuffer: LinkedHashSet[Global.Symbol]

29. #### def innerClassSymbolFor(s: Global.Symbol): Global.Symbol

    For given symbol return a symbol corresponding to a class that should be declared as inner class.

    For given symbol return a symbol corresponding to a class that should be declared as inner class.

    For example: class A { class B object C }

    then method will return: NoSymbol for A, the same symbol for A.B (corresponding to A$B class), and A$C$ symbol for A.C.

30. #### def isDeprecated(sym: Global.Symbol): Boolean

31. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

32. #### def javaArrayType(elem: Type): Type

33. #### def javaName(sym: Global.Symbol): String

    Return the name of this symbol that can be used on the Java platform.

    Return the name of this symbol that can be used on the Java platform. It removes spaces from names.

    Special handling: scala.Nothing erases to scala.runtime.Nothing$ scala.Null erases to scala.runtime.Null$

    This is needed because they are not real classes, and they mean 'abrupt termination upon evaluation of that expression' or null respectively. This handling is done already in GenICode, but here we need to remove references from method signatures to these types, because such classes cannot exist in the classpath: the type checker will be very confused.

34. #### def javaType(s: Global.Symbol): Type

35. #### def javaType(t: Global.Type): Type

36. #### def javaType(tk: Global.icodes.TypeKind): Type

37. #### val mdesc_arglessvoid: String

38. #### def mkArray(xs: Traversable[String]): Array[String]

    Specialized array conversion to prevent calling java.lang.reflect.Array.newInstance via TraversableOnce.toArray

39. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

40. #### final def notify(): Unit

    Definition Classes
      AnyRef

41. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

42. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

43. #### def toString(): String

    Definition Classes
      AnyRef → Any

44. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

47. #### def writeIfNotTooBig(label: String, jclassName: String, jclass: ClassWriter, sym: Global.Symbol): Unit

48. #### def →[B](y: B): (JBuilder, B)

    Implicit information
      This member is added by an implicit conversion from JBuilder to ArrowAssoc[JBuilder] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from JBuilder to any2stringadd[JBuilder]

### Inherited by implicit conversion StringFormat from JBuilder to StringFormat[JBuilder]

### Inherited by implicit conversion Ensuring from JBuilder to Ensuring[JBuilder]

### Inherited by implicit conversion ArrowAssoc from JBuilder to ArrowAssoc[JBuilder]

### Ungrouped